/* -------------------------------------------------------------------------
**                Universidade Estacio de Sa' - Campus Barra
** -------------------------------------------------------------------------
** TRABALHO FINAL DE PROGRAMACAO II.
** -------------------------------------------------------------------------
** Curso:     Programacao II - Noite
** Professor: Marcio Santi
** Aluno:     Nome_do_aluno / Matricula_do_aluno
** Arquivo:   reg.c
** Descricao: Arquivo para manipulacao dos registros da agenda.
** Data:      26-Out-2000
** -------------------------------------------------------------------------
*/
#include <stdio.h>
#include <stdlib.h>

#include "str.h"
#include "reg.h"

/* -------------------------------------------------------------------------
** Definicoes locais:
*/
#define TAM_ALLOC 5

/* -------------------------------------------------------------------------
** Variaveis locais (globais no arquivo):
*/
static int   NumAlloc = 0;      /* Numero de registros alocados */
static int   NumReg   = 0;      /* Numero de registros */
static tReg *Registro = NULL;   /* Vetor de registros  */

/* -------------------------------------------------------------------------
** Funcoes locais:
*/
static void LiberaMemoria(void);
static int  LeArquivo    (void);
static int  GravaArquivo (void);
static void ImprimeReg   (tReg *reg);
static void CopiaReg     (tReg *regd, tReg *rego);

/* =========================== LiberaMemoria ============================ */

static void LiberaMemoria(void)
{
  if (Registro == NULL) return;

  NumAlloc = 0;
  NumReg   = 0;

  free(Registro);
  Registro = NULL;
}

/* ============================= LeArquivo ============================== */

static int LeArquivo(void)
{
  FILE *f;

  /* Abre o arquivo binario para leitura.
  */

        /* COMPLETE AQUI */

  /* Liberar a memoria alocada para os registros.
  */

        /* COMPLETE AQUI */

  /* Le o numero de registros e aloca memoria.
  */

        /* COMPLETE AQUI */

  /* Le os registros e fecha o arquivo.
  */

        /* COMPLETE AQUI */

  return(1);
}

/* ============================= GravaArquivo =========================== */

static int GravaArquivo(void)
{
  FILE *f;

  /* Abre o arquivo binario para gravacao.
  */

        /* COMPLETE AQUI */

  /* Grava os registros e fecha o arquivo binario.
  */


        /* COMPLETE AQUI */

  return(1);
}

/* ============================== ImprimeReg ============================ */

static void ImprimeReg(tReg *reg)
{
        /* COMPLETE AQUI */
}

/* ============================== CopiaReg ============================== */

static void CopiaReg(tReg *regd, tReg *rego)
{
        /* COMPLETE AQUI */
}

/* -------------------------------------------------------------------------
** Funcoes publicas:
*/

/* ============================== RegInicia ============================= */

void RegInicia(void)
{
  int ret;

  /* Le os dados ja' armazenadas.
  */
  ret = /* COMPLETE AQUI */;

  /* Se nao existem registros gravados entao se prepara para receber os
  ** registros iniciais.
  */
  if (!ret)
  {
    NumAlloc = TAM_ALLOC;
    Registro = (tReg *) realloc(Registro, NumAlloc*sizeof(tReg));
  }
}

/* ============================== RegTermina ============================ */

void RegTermina(void)
{
  /* Grava os registros existentes e libera a memoria utilizada.
  */

       /* COMPLETE AQUI */
}

/* ============================ RegInsereOrd ============================ */

void RegInsereOrd(tReg *reg)
{
  int i,pos;

  /* Determinacao do ponto de insercao.
  */

  /* COMPLETE AQUI */

  /* Deslocamento dos elementos para a direita (i => i+1).
  */
  for (i = NumReg-1; i >= pos; i--) Registro[i+1] = Registro[i];

  /* Insercao do novo elemento (copia do registro passado).
  */

         /* COMPLETE AQUI */

  /* Aloca espaco para os proximos elementos.
  */
  if (NumReg == NumAlloc)
  {
    /* COMPLETE AQUI */
  }
}

/* ============================== RegRemove ============================= */

int RegRemove(int pos)
{
  int i;

  /* Verifica se o indice e' valido.
  */

     /* COMPLETE AQUI */

  /* Retira o registro do vetor.
  */

     /* COMPLETE AQUI */

  return(1);
}

/* ============================ RegListaNome ============================ */

void RegListaNome(void)
{
  int i;

  for (i = 0; i < NumReg; i++)
  {
    printf("%3d|%s|\n", i,Registro[i].nome);
  }
}

/* ============================= RegListaPadr =========================== */

void RegListaPadr(char *txt)
{
  int i;
  int n = 0;;

  printf("------------------------------------\n");
  for (i = 0; i < NumReg; i++)
  {
    if (StrFnd(Registro[i].nome, txt))
    {
      n++;
      printf("Registro %d\n", i);
      ImprimeReg(&Registro[i]);
      printf("------------------------------------\n");
    }
  }

  if (n == 0)
  {
    printf("Padrao nao encontrado.\n"); 
    printf("------------------------------------\n");
  }
}

/* ============================= RegListaInd =========================== */

void RegListaInd( int ind )
{
  printf("------------------------------------\n");
  if( (0 <= ind) && (ind < NumReg) )
  {
    printf("Registro %d\n", ind);
    ImprimeReg(&Registro[ind]);
    printf("------------------------------------\n");
  }
  else
  {
    printf("Indice nao existe.\n"); 
    printf("------------------------------------\n");
  }
}

/* ================================================= Fim do arquivo ===== */
